import * as cdktf from 'cdktf';
import { DashboardWidgetTimeseriesDefinitionCustomLink, DashboardWidgetTimeseriesDefinitionEvent, DashboardWidgetTimeseriesDefinitionMarker, DashboardWidgetTimeseriesDefinitionRequest, DashboardWidgetGroupDefinition, DashboardWidgetHeatmapDefinition, DashboardWidgetHostmapDefinition, DashboardWidgetIframeDefinition, DashboardWidgetImageDefinition, DashboardWidgetLogStreamDefinition, DashboardWidgetManageStatusDefinition, DashboardWidgetNoteDefinition, DashboardWidgetQueryTableDefinition, DashboardWidgetQueryValueDefinition, DashboardWidgetScatterplotDefinition, DashboardWidgetServiceLevelObjectiveDefinition, DashboardWidgetServicemapDefinition } from './structs400';
import { DashboardWidgetAlertGraphDefinition, DashboardWidgetAlertValueDefinition, DashboardWidgetChangeDefinition, DashboardWidgetCheckStatusDefinition, DashboardWidgetDistributionDefinition, DashboardWidgetEventStreamDefinition, DashboardWidgetEventTimelineDefinition, DashboardWidgetFreeTextDefinition, DashboardWidgetGeomapDefinition } from './structs0';
/**
 * @stability stable
 */
export interface DashboardWidgetTimeseriesDefinitionRightYaxis {
    /**
     * Always include zero or fit the axis to the data range.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#include_zero Dashboard#include_zero}
     *
     * @stability stable
     */
    readonly includeZero?: boolean | cdktf.IResolvable;
    /**
     * The label of the axis to display on the graph.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#label Dashboard#label}
     *
     * @stability stable
     */
    readonly label?: string;
    /**
     * Specify the maximum value to show on the Y-axis.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#max Dashboard#max}
     *
     * @stability stable
     */
    readonly max?: string;
    /**
     * Specify the minimum value to show on the Y-axis.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#min Dashboard#min}
     *
     * @stability stable
     */
    readonly min?: string;
    /**
     * Specify the scale type, options: `linear`, `log`, `pow`, `sqrt`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#scale Dashboard#scale}
     *
     * @stability stable
     */
    readonly scale?: string;
}
export declare function dashboardWidgetTimeseriesDefinitionRightYaxisToTerraform(struct?: DashboardWidgetTimeseriesDefinitionRightYaxisOutputReference | DashboardWidgetTimeseriesDefinitionRightYaxis): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetTimeseriesDefinitionRightYaxisOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetTimeseriesDefinitionRightYaxis | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetTimeseriesDefinitionRightYaxis | undefined);
    private _includeZero?;
    /**
     * @stability stable
     */
    get includeZero(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeZero(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeZero(): void;
    /**
     * @stability stable
     */
    get includeZeroInput(): boolean | cdktf.IResolvable | undefined;
    private _label?;
    /**
     * @stability stable
     */
    get label(): string;
    /**
     * @stability stable
     */
    set label(value: string);
    /**
     * @stability stable
     */
    resetLabel(): void;
    /**
     * @stability stable
     */
    get labelInput(): string | undefined;
    private _max?;
    /**
     * @stability stable
     */
    get max(): string;
    /**
     * @stability stable
     */
    set max(value: string);
    /**
     * @stability stable
     */
    resetMax(): void;
    /**
     * @stability stable
     */
    get maxInput(): string | undefined;
    private _min?;
    /**
     * @stability stable
     */
    get min(): string;
    /**
     * @stability stable
     */
    set min(value: string);
    /**
     * @stability stable
     */
    resetMin(): void;
    /**
     * @stability stable
     */
    get minInput(): string | undefined;
    private _scale?;
    /**
     * @stability stable
     */
    get scale(): string;
    /**
     * @stability stable
     */
    set scale(value: string);
    /**
     * @stability stable
     */
    resetScale(): void;
    /**
     * @stability stable
     */
    get scaleInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetTimeseriesDefinitionYaxis {
    /**
     * Always include zero or fit the axis to the data range.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#include_zero Dashboard#include_zero}
     *
     * @stability stable
     */
    readonly includeZero?: boolean | cdktf.IResolvable;
    /**
     * The label of the axis to display on the graph.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#label Dashboard#label}
     *
     * @stability stable
     */
    readonly label?: string;
    /**
     * Specify the maximum value to show on the Y-axis.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#max Dashboard#max}
     *
     * @stability stable
     */
    readonly max?: string;
    /**
     * Specify the minimum value to show on the Y-axis.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#min Dashboard#min}
     *
     * @stability stable
     */
    readonly min?: string;
    /**
     * Specify the scale type, options: `linear`, `log`, `pow`, `sqrt`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#scale Dashboard#scale}
     *
     * @stability stable
     */
    readonly scale?: string;
}
export declare function dashboardWidgetTimeseriesDefinitionYaxisToTerraform(struct?: DashboardWidgetTimeseriesDefinitionYaxisOutputReference | DashboardWidgetTimeseriesDefinitionYaxis): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetTimeseriesDefinitionYaxisOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetTimeseriesDefinitionYaxis | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetTimeseriesDefinitionYaxis | undefined);
    private _includeZero?;
    /**
     * @stability stable
     */
    get includeZero(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeZero(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeZero(): void;
    /**
     * @stability stable
     */
    get includeZeroInput(): boolean | cdktf.IResolvable | undefined;
    private _label?;
    /**
     * @stability stable
     */
    get label(): string;
    /**
     * @stability stable
     */
    set label(value: string);
    /**
     * @stability stable
     */
    resetLabel(): void;
    /**
     * @stability stable
     */
    get labelInput(): string | undefined;
    private _max?;
    /**
     * @stability stable
     */
    get max(): string;
    /**
     * @stability stable
     */
    set max(value: string);
    /**
     * @stability stable
     */
    resetMax(): void;
    /**
     * @stability stable
     */
    get maxInput(): string | undefined;
    private _min?;
    /**
     * @stability stable
     */
    get min(): string;
    /**
     * @stability stable
     */
    set min(value: string);
    /**
     * @stability stable
     */
    resetMin(): void;
    /**
     * @stability stable
     */
    get minInput(): string | undefined;
    private _scale?;
    /**
     * @stability stable
     */
    get scale(): string;
    /**
     * @stability stable
     */
    set scale(value: string);
    /**
     * @stability stable
     */
    resetScale(): void;
    /**
     * @stability stable
     */
    get scaleInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetTimeseriesDefinition {
    /**
     * A list of columns to display in the legend. Valid values are `value`, `avg`, `sum`, `min`, `max`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#legend_columns Dashboard#legend_columns}
     *
     * @stability stable
     */
    readonly legendColumns?: string[];
    /**
     * The layout of the legend displayed in the widget. Valid values are `auto`, `horizontal`, `vertical`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#legend_layout Dashboard#legend_layout}
     *
     * @stability stable
     */
    readonly legendLayout?: string;
    /**
     * The size of the legend displayed in the widget.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#legend_size Dashboard#legend_size}
     *
     * @stability stable
     */
    readonly legendSize?: string;
    /**
     * The timeframe to use when displaying the widget.
     *
     * Valid values are `1m`, `5m`, `10m`, `15m`, `30m`, `1h`, `4h`, `1d`, `2d`, `1w`, `1mo`, `3mo`, `6mo`, `1y`, `alert`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#live_span Dashboard#live_span}
     *
     * @stability stable
     */
    readonly liveSpan?: string;
    /**
     * Whether or not to show the legend on this widget.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#show_legend Dashboard#show_legend}
     *
     * @stability stable
     */
    readonly showLegend?: boolean | cdktf.IResolvable;
    /**
     * The title of the widget.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#title Dashboard#title}
     *
     * @stability stable
     */
    readonly title?: string;
    /**
     * The alignment of the widget's title. Valid values are `center`, `left`, `right`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#title_align Dashboard#title_align}
     *
     * @stability stable
     */
    readonly titleAlign?: string;
    /**
     * The size of the widget's title (defaults to 16).
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#title_size Dashboard#title_size}
     *
     * @stability stable
     */
    readonly titleSize?: string;
    /**
     * custom_link block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#custom_link Dashboard#custom_link}
     *
     * @stability stable
     */
    readonly customLink?: DashboardWidgetTimeseriesDefinitionCustomLink[];
    /**
     * event block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#event Dashboard#event}
     *
     * @stability stable
     */
    readonly event?: DashboardWidgetTimeseriesDefinitionEvent[];
    /**
     * marker block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#marker Dashboard#marker}
     *
     * @stability stable
     */
    readonly marker?: DashboardWidgetTimeseriesDefinitionMarker[];
    /**
     * request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#request Dashboard#request}
     *
     * @stability stable
     */
    readonly request?: DashboardWidgetTimeseriesDefinitionRequest[];
    /**
     * right_yaxis block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#right_yaxis Dashboard#right_yaxis}
     *
     * @stability stable
     */
    readonly rightYaxis?: DashboardWidgetTimeseriesDefinitionRightYaxis;
    /**
     * yaxis block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#yaxis Dashboard#yaxis}
     *
     * @stability stable
     */
    readonly yaxis?: DashboardWidgetTimeseriesDefinitionYaxis;
}
export declare function dashboardWidgetTimeseriesDefinitionToTerraform(struct?: DashboardWidgetTimeseriesDefinitionOutputReference | DashboardWidgetTimeseriesDefinition): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetTimeseriesDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetTimeseriesDefinition | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetTimeseriesDefinition | undefined);
    private _legendColumns?;
    /**
     * @stability stable
     */
    get legendColumns(): string[];
    /**
     * @stability stable
     */
    set legendColumns(value: string[]);
    /**
     * @stability stable
     */
    resetLegendColumns(): void;
    /**
     * @stability stable
     */
    get legendColumnsInput(): string[] | undefined;
    private _legendLayout?;
    /**
     * @stability stable
     */
    get legendLayout(): string;
    /**
     * @stability stable
     */
    set legendLayout(value: string);
    /**
     * @stability stable
     */
    resetLegendLayout(): void;
    /**
     * @stability stable
     */
    get legendLayoutInput(): string | undefined;
    private _legendSize?;
    /**
     * @stability stable
     */
    get legendSize(): string;
    /**
     * @stability stable
     */
    set legendSize(value: string);
    /**
     * @stability stable
     */
    resetLegendSize(): void;
    /**
     * @stability stable
     */
    get legendSizeInput(): string | undefined;
    private _liveSpan?;
    /**
     * @stability stable
     */
    get liveSpan(): string;
    /**
     * @stability stable
     */
    set liveSpan(value: string);
    /**
     * @stability stable
     */
    resetLiveSpan(): void;
    /**
     * @stability stable
     */
    get liveSpanInput(): string | undefined;
    private _showLegend?;
    /**
     * @stability stable
     */
    get showLegend(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set showLegend(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetShowLegend(): void;
    /**
     * @stability stable
     */
    get showLegendInput(): boolean | cdktf.IResolvable | undefined;
    private _title?;
    /**
     * @stability stable
     */
    get title(): string;
    /**
     * @stability stable
     */
    set title(value: string);
    /**
     * @stability stable
     */
    resetTitle(): void;
    /**
     * @stability stable
     */
    get titleInput(): string | undefined;
    private _titleAlign?;
    /**
     * @stability stable
     */
    get titleAlign(): string;
    /**
     * @stability stable
     */
    set titleAlign(value: string);
    /**
     * @stability stable
     */
    resetTitleAlign(): void;
    /**
     * @stability stable
     */
    get titleAlignInput(): string | undefined;
    private _titleSize?;
    /**
     * @stability stable
     */
    get titleSize(): string;
    /**
     * @stability stable
     */
    set titleSize(value: string);
    /**
     * @stability stable
     */
    resetTitleSize(): void;
    /**
     * @stability stable
     */
    get titleSizeInput(): string | undefined;
    private _customLink?;
    /**
     * @stability stable
     */
    get customLink(): DashboardWidgetTimeseriesDefinitionCustomLink[];
    /**
     * @stability stable
     */
    set customLink(value: DashboardWidgetTimeseriesDefinitionCustomLink[]);
    /**
     * @stability stable
     */
    resetCustomLink(): void;
    /**
     * @stability stable
     */
    get customLinkInput(): DashboardWidgetTimeseriesDefinitionCustomLink[] | undefined;
    private _event?;
    /**
     * @stability stable
     */
    get event(): DashboardWidgetTimeseriesDefinitionEvent[];
    /**
     * @stability stable
     */
    set event(value: DashboardWidgetTimeseriesDefinitionEvent[]);
    /**
     * @stability stable
     */
    resetEvent(): void;
    /**
     * @stability stable
     */
    get eventInput(): DashboardWidgetTimeseriesDefinitionEvent[] | undefined;
    private _marker?;
    /**
     * @stability stable
     */
    get marker(): DashboardWidgetTimeseriesDefinitionMarker[];
    /**
     * @stability stable
     */
    set marker(value: DashboardWidgetTimeseriesDefinitionMarker[]);
    /**
     * @stability stable
     */
    resetMarker(): void;
    /**
     * @stability stable
     */
    get markerInput(): DashboardWidgetTimeseriesDefinitionMarker[] | undefined;
    private _request?;
    /**
     * @stability stable
     */
    get request(): DashboardWidgetTimeseriesDefinitionRequest[];
    /**
     * @stability stable
     */
    set request(value: DashboardWidgetTimeseriesDefinitionRequest[]);
    /**
     * @stability stable
     */
    resetRequest(): void;
    /**
     * @stability stable
     */
    get requestInput(): DashboardWidgetTimeseriesDefinitionRequest[] | undefined;
    private _rightYaxis;
    /**
     * @stability stable
     */
    get rightYaxis(): DashboardWidgetTimeseriesDefinitionRightYaxisOutputReference;
    /**
     * @stability stable
     */
    putRightYaxis(value: DashboardWidgetTimeseriesDefinitionRightYaxis): void;
    /**
     * @stability stable
     */
    resetRightYaxis(): void;
    /**
     * @stability stable
     */
    get rightYaxisInput(): DashboardWidgetTimeseriesDefinitionRightYaxis | undefined;
    private _yaxis;
    /**
     * @stability stable
     */
    get yaxis(): DashboardWidgetTimeseriesDefinitionYaxisOutputReference;
    /**
     * @stability stable
     */
    putYaxis(value: DashboardWidgetTimeseriesDefinitionYaxis): void;
    /**
     * @stability stable
     */
    resetYaxis(): void;
    /**
     * @stability stable
     */
    get yaxisInput(): DashboardWidgetTimeseriesDefinitionYaxis | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionCustomLink {
    /**
     * The flag for toggling context menu link visibility.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#is_hidden Dashboard#is_hidden}
     *
     * @stability stable
     */
    readonly isHidden?: boolean | cdktf.IResolvable;
    /**
     * The label for the custom link URL.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#label Dashboard#label}
     *
     * @stability stable
     */
    readonly label?: string;
    /**
     * The URL of the custom link.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#link Dashboard#link}
     *
     * @stability stable
     */
    readonly link?: string;
    /**
     * The label id that refers to a context menu link item.
     *
     * When override_label is provided, the client request omits the label field.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#override_label Dashboard#override_label}
     *
     * @stability stable
     */
    readonly overrideLabel?: string;
}
export declare function dashboardWidgetToplistDefinitionCustomLinkToTerraform(struct?: DashboardWidgetToplistDefinitionCustomLink): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestApmQueryComputeQuery {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Define the time interval in seconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestApmQueryComputeQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestApmQueryComputeQueryOutputReference | DashboardWidgetToplistDefinitionRequestApmQueryComputeQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestApmQueryComputeQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestApmQueryComputeQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestApmQueryComputeQuery | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _facet?;
    /**
     * @stability stable
     */
    get facet(): string;
    /**
     * @stability stable
     */
    set facet(value: string);
    /**
     * @stability stable
     */
    resetFacet(): void;
    /**
     * @stability stable
     */
    get facetInput(): string | undefined;
    private _interval?;
    /**
     * @stability stable
     */
    get interval(): number;
    /**
     * @stability stable
     */
    set interval(value: number);
    /**
     * @stability stable
     */
    resetInterval(): void;
    /**
     * @stability stable
     */
    get intervalInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestApmQueryGroupBySortQuery {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Widget sorting methods. Valid values are `asc`, `desc`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#order Dashboard#order}
     *
     * @stability stable
     */
    readonly order: string;
}
export declare function dashboardWidgetToplistDefinitionRequestApmQueryGroupBySortQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestApmQueryGroupBySortQueryOutputReference | DashboardWidgetToplistDefinitionRequestApmQueryGroupBySortQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestApmQueryGroupBySortQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestApmQueryGroupBySortQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestApmQueryGroupBySortQuery | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _facet?;
    /**
     * @stability stable
     */
    get facet(): string;
    /**
     * @stability stable
     */
    set facet(value: string);
    /**
     * @stability stable
     */
    resetFacet(): void;
    /**
     * @stability stable
     */
    get facetInput(): string | undefined;
    private _order?;
    /**
     * @stability stable
     */
    get order(): string;
    /**
     * @stability stable
     */
    set order(value: string);
    /**
     * @stability stable
     */
    get orderInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestApmQueryGroupBy {
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * The maximum number of items in the group.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#limit Dashboard#limit}
     *
     * @stability stable
     */
    readonly limit?: number;
    /**
     * sort_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#sort_query Dashboard#sort_query}
     *
     * @stability stable
     */
    readonly sortQuery?: DashboardWidgetToplistDefinitionRequestApmQueryGroupBySortQuery;
}
export declare function dashboardWidgetToplistDefinitionRequestApmQueryGroupByToTerraform(struct?: DashboardWidgetToplistDefinitionRequestApmQueryGroupBy): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestApmQueryMultiCompute {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Define the time interval in seconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestApmQueryMultiComputeToTerraform(struct?: DashboardWidgetToplistDefinitionRequestApmQueryMultiCompute): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestApmQuery {
    /**
     * The name of the index to query.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#index Dashboard#index}
     *
     * @stability stable
     */
    readonly index: string;
    /**
     * The search query to use.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#search_query Dashboard#search_query}
     *
     * @stability stable
     */
    readonly searchQuery?: string;
    /**
     * compute_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#compute_query Dashboard#compute_query}
     *
     * @stability stable
     */
    readonly computeQuery?: DashboardWidgetToplistDefinitionRequestApmQueryComputeQuery;
    /**
     * group_by block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#group_by Dashboard#group_by}
     *
     * @stability stable
     */
    readonly groupBy?: DashboardWidgetToplistDefinitionRequestApmQueryGroupBy[];
    /**
     * multi_compute block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#multi_compute Dashboard#multi_compute}
     *
     * @stability stable
     */
    readonly multiCompute?: DashboardWidgetToplistDefinitionRequestApmQueryMultiCompute[];
}
export declare function dashboardWidgetToplistDefinitionRequestApmQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestApmQueryOutputReference | DashboardWidgetToplistDefinitionRequestApmQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestApmQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestApmQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestApmQuery | undefined);
    private _index?;
    /**
     * @stability stable
     */
    get index(): string;
    /**
     * @stability stable
     */
    set index(value: string);
    /**
     * @stability stable
     */
    get indexInput(): string | undefined;
    private _searchQuery?;
    /**
     * @stability stable
     */
    get searchQuery(): string;
    /**
     * @stability stable
     */
    set searchQuery(value: string);
    /**
     * @stability stable
     */
    resetSearchQuery(): void;
    /**
     * @stability stable
     */
    get searchQueryInput(): string | undefined;
    private _computeQuery;
    /**
     * @stability stable
     */
    get computeQuery(): DashboardWidgetToplistDefinitionRequestApmQueryComputeQueryOutputReference;
    /**
     * @stability stable
     */
    putComputeQuery(value: DashboardWidgetToplistDefinitionRequestApmQueryComputeQuery): void;
    /**
     * @stability stable
     */
    resetComputeQuery(): void;
    /**
     * @stability stable
     */
    get computeQueryInput(): DashboardWidgetToplistDefinitionRequestApmQueryComputeQuery | undefined;
    private _groupBy?;
    /**
     * @stability stable
     */
    get groupBy(): DashboardWidgetToplistDefinitionRequestApmQueryGroupBy[];
    /**
     * @stability stable
     */
    set groupBy(value: DashboardWidgetToplistDefinitionRequestApmQueryGroupBy[]);
    /**
     * @stability stable
     */
    resetGroupBy(): void;
    /**
     * @stability stable
     */
    get groupByInput(): DashboardWidgetToplistDefinitionRequestApmQueryGroupBy[] | undefined;
    private _multiCompute?;
    /**
     * @stability stable
     */
    get multiCompute(): DashboardWidgetToplistDefinitionRequestApmQueryMultiCompute[];
    /**
     * @stability stable
     */
    set multiCompute(value: DashboardWidgetToplistDefinitionRequestApmQueryMultiCompute[]);
    /**
     * @stability stable
     */
    resetMultiCompute(): void;
    /**
     * @stability stable
     */
    get multiComputeInput(): DashboardWidgetToplistDefinitionRequestApmQueryMultiCompute[] | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestAuditQueryComputeQuery {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Define the time interval in seconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestAuditQueryComputeQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestAuditQueryComputeQueryOutputReference | DashboardWidgetToplistDefinitionRequestAuditQueryComputeQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestAuditQueryComputeQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestAuditQueryComputeQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestAuditQueryComputeQuery | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _facet?;
    /**
     * @stability stable
     */
    get facet(): string;
    /**
     * @stability stable
     */
    set facet(value: string);
    /**
     * @stability stable
     */
    resetFacet(): void;
    /**
     * @stability stable
     */
    get facetInput(): string | undefined;
    private _interval?;
    /**
     * @stability stable
     */
    get interval(): number;
    /**
     * @stability stable
     */
    set interval(value: number);
    /**
     * @stability stable
     */
    resetInterval(): void;
    /**
     * @stability stable
     */
    get intervalInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestAuditQueryGroupBySortQuery {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Widget sorting methods. Valid values are `asc`, `desc`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#order Dashboard#order}
     *
     * @stability stable
     */
    readonly order: string;
}
export declare function dashboardWidgetToplistDefinitionRequestAuditQueryGroupBySortQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestAuditQueryGroupBySortQueryOutputReference | DashboardWidgetToplistDefinitionRequestAuditQueryGroupBySortQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestAuditQueryGroupBySortQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestAuditQueryGroupBySortQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestAuditQueryGroupBySortQuery | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _facet?;
    /**
     * @stability stable
     */
    get facet(): string;
    /**
     * @stability stable
     */
    set facet(value: string);
    /**
     * @stability stable
     */
    resetFacet(): void;
    /**
     * @stability stable
     */
    get facetInput(): string | undefined;
    private _order?;
    /**
     * @stability stable
     */
    get order(): string;
    /**
     * @stability stable
     */
    set order(value: string);
    /**
     * @stability stable
     */
    get orderInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestAuditQueryGroupBy {
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * The maximum number of items in the group.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#limit Dashboard#limit}
     *
     * @stability stable
     */
    readonly limit?: number;
    /**
     * sort_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#sort_query Dashboard#sort_query}
     *
     * @stability stable
     */
    readonly sortQuery?: DashboardWidgetToplistDefinitionRequestAuditQueryGroupBySortQuery;
}
export declare function dashboardWidgetToplistDefinitionRequestAuditQueryGroupByToTerraform(struct?: DashboardWidgetToplistDefinitionRequestAuditQueryGroupBy): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestAuditQueryMultiCompute {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Define the time interval in seconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestAuditQueryMultiComputeToTerraform(struct?: DashboardWidgetToplistDefinitionRequestAuditQueryMultiCompute): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestAuditQuery {
    /**
     * The name of the index to query.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#index Dashboard#index}
     *
     * @stability stable
     */
    readonly index: string;
    /**
     * The search query to use.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#search_query Dashboard#search_query}
     *
     * @stability stable
     */
    readonly searchQuery?: string;
    /**
     * compute_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#compute_query Dashboard#compute_query}
     *
     * @stability stable
     */
    readonly computeQuery?: DashboardWidgetToplistDefinitionRequestAuditQueryComputeQuery;
    /**
     * group_by block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#group_by Dashboard#group_by}
     *
     * @stability stable
     */
    readonly groupBy?: DashboardWidgetToplistDefinitionRequestAuditQueryGroupBy[];
    /**
     * multi_compute block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#multi_compute Dashboard#multi_compute}
     *
     * @stability stable
     */
    readonly multiCompute?: DashboardWidgetToplistDefinitionRequestAuditQueryMultiCompute[];
}
export declare function dashboardWidgetToplistDefinitionRequestAuditQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestAuditQueryOutputReference | DashboardWidgetToplistDefinitionRequestAuditQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestAuditQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestAuditQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestAuditQuery | undefined);
    private _index?;
    /**
     * @stability stable
     */
    get index(): string;
    /**
     * @stability stable
     */
    set index(value: string);
    /**
     * @stability stable
     */
    get indexInput(): string | undefined;
    private _searchQuery?;
    /**
     * @stability stable
     */
    get searchQuery(): string;
    /**
     * @stability stable
     */
    set searchQuery(value: string);
    /**
     * @stability stable
     */
    resetSearchQuery(): void;
    /**
     * @stability stable
     */
    get searchQueryInput(): string | undefined;
    private _computeQuery;
    /**
     * @stability stable
     */
    get computeQuery(): DashboardWidgetToplistDefinitionRequestAuditQueryComputeQueryOutputReference;
    /**
     * @stability stable
     */
    putComputeQuery(value: DashboardWidgetToplistDefinitionRequestAuditQueryComputeQuery): void;
    /**
     * @stability stable
     */
    resetComputeQuery(): void;
    /**
     * @stability stable
     */
    get computeQueryInput(): DashboardWidgetToplistDefinitionRequestAuditQueryComputeQuery | undefined;
    private _groupBy?;
    /**
     * @stability stable
     */
    get groupBy(): DashboardWidgetToplistDefinitionRequestAuditQueryGroupBy[];
    /**
     * @stability stable
     */
    set groupBy(value: DashboardWidgetToplistDefinitionRequestAuditQueryGroupBy[]);
    /**
     * @stability stable
     */
    resetGroupBy(): void;
    /**
     * @stability stable
     */
    get groupByInput(): DashboardWidgetToplistDefinitionRequestAuditQueryGroupBy[] | undefined;
    private _multiCompute?;
    /**
     * @stability stable
     */
    get multiCompute(): DashboardWidgetToplistDefinitionRequestAuditQueryMultiCompute[];
    /**
     * @stability stable
     */
    set multiCompute(value: DashboardWidgetToplistDefinitionRequestAuditQueryMultiCompute[]);
    /**
     * @stability stable
     */
    resetMultiCompute(): void;
    /**
     * @stability stable
     */
    get multiComputeInput(): DashboardWidgetToplistDefinitionRequestAuditQueryMultiCompute[] | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestConditionalFormats {
    /**
     * The comparator to use. Valid values are `>`, `>=`, `<`, `<=`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#comparator Dashboard#comparator}
     *
     * @stability stable
     */
    readonly comparator: string;
    /**
     * The color palette to apply to the background, same values available as palette.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#custom_bg_color Dashboard#custom_bg_color}
     *
     * @stability stable
     */
    readonly customBgColor?: string;
    /**
     * The color palette to apply to the foreground, same values available as palette.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#custom_fg_color Dashboard#custom_fg_color}
     *
     * @stability stable
     */
    readonly customFgColor?: string;
    /**
     * Setting this to True hides values.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#hide_value Dashboard#hide_value}
     *
     * @stability stable
     */
    readonly hideValue?: boolean | cdktf.IResolvable;
    /**
     * Displays an image as the background.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#image_url Dashboard#image_url}
     *
     * @stability stable
     */
    readonly imageUrl?: string;
    /**
     * The metric from the request to correlate with this conditional format.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#metric Dashboard#metric}
     *
     * @stability stable
     */
    readonly metric?: string;
    /**
     * The color palette to apply.
     *
     * Valid values are `blue`, `custom_bg`, `custom_image`, `custom_text`, `gray_on_white`, `grey`, `green`, `orange`, `red`, `red_on_white`, `white_on_gray`, `white_on_green`, `green_on_white`, `white_on_red`, `white_on_yellow`, `yellow_on_white`, `black_on_light_yellow`, `black_on_light_green`, `black_on_light_red`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#palette Dashboard#palette}
     *
     * @stability stable
     */
    readonly palette: string;
    /**
     * Defines the displayed timeframe.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#timeframe Dashboard#timeframe}
     *
     * @stability stable
     */
    readonly timeframe?: string;
    /**
     * A value for the comparator.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#value Dashboard#value}
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function dashboardWidgetToplistDefinitionRequestConditionalFormatsToTerraform(struct?: DashboardWidgetToplistDefinitionRequestConditionalFormats): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestFormulaConditionalFormats {
    /**
     * The comparator to use. Valid values are `>`, `>=`, `<`, `<=`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#comparator Dashboard#comparator}
     *
     * @stability stable
     */
    readonly comparator: string;
    /**
     * The color palette to apply to the background, same values available as palette.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#custom_bg_color Dashboard#custom_bg_color}
     *
     * @stability stable
     */
    readonly customBgColor?: string;
    /**
     * The color palette to apply to the foreground, same values available as palette.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#custom_fg_color Dashboard#custom_fg_color}
     *
     * @stability stable
     */
    readonly customFgColor?: string;
    /**
     * Setting this to True hides values.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#hide_value Dashboard#hide_value}
     *
     * @stability stable
     */
    readonly hideValue?: boolean | cdktf.IResolvable;
    /**
     * Displays an image as the background.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#image_url Dashboard#image_url}
     *
     * @stability stable
     */
    readonly imageUrl?: string;
    /**
     * The metric from the request to correlate with this conditional format.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#metric Dashboard#metric}
     *
     * @stability stable
     */
    readonly metric?: string;
    /**
     * The color palette to apply.
     *
     * Valid values are `blue`, `custom_bg`, `custom_image`, `custom_text`, `gray_on_white`, `grey`, `green`, `orange`, `red`, `red_on_white`, `white_on_gray`, `white_on_green`, `green_on_white`, `white_on_red`, `white_on_yellow`, `yellow_on_white`, `black_on_light_yellow`, `black_on_light_green`, `black_on_light_red`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#palette Dashboard#palette}
     *
     * @stability stable
     */
    readonly palette: string;
    /**
     * Defines the displayed timeframe.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#timeframe Dashboard#timeframe}
     *
     * @stability stable
     */
    readonly timeframe?: string;
    /**
     * A value for the comparator.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#value Dashboard#value}
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function dashboardWidgetToplistDefinitionRequestFormulaConditionalFormatsToTerraform(struct?: DashboardWidgetToplistDefinitionRequestFormulaConditionalFormats): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestFormulaLimit {
    /**
     * The number of results to return.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#count Dashboard#count}
     *
     * @stability stable
     */
    readonly count?: number;
    /**
     * The direction of the sort. Valid values are `asc`, `desc`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#order Dashboard#order}
     *
     * @stability stable
     */
    readonly order?: string;
}
export declare function dashboardWidgetToplistDefinitionRequestFormulaLimitToTerraform(struct?: DashboardWidgetToplistDefinitionRequestFormulaLimitOutputReference | DashboardWidgetToplistDefinitionRequestFormulaLimit): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestFormulaLimitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestFormulaLimit | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestFormulaLimit | undefined);
    private _count?;
    /**
     * @stability stable
     */
    get count(): number;
    /**
     * @stability stable
     */
    set count(value: number);
    /**
     * @stability stable
     */
    resetCount(): void;
    /**
     * @stability stable
     */
    get countInput(): number | undefined;
    private _order?;
    /**
     * @stability stable
     */
    get order(): string;
    /**
     * @stability stable
     */
    set order(value: string);
    /**
     * @stability stable
     */
    resetOrder(): void;
    /**
     * @stability stable
     */
    get orderInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestFormula {
    /**
     * An expression alias.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#alias Dashboard#alias}
     *
     * @stability stable
     */
    readonly alias?: string;
    /**
     * A list of display modes for each table cell. Valid values are `number`, `bar`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#cell_display_mode Dashboard#cell_display_mode}
     *
     * @stability stable
     */
    readonly cellDisplayMode?: string;
    /**
     * A string expression built from queries, formulas, and functions.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#formula_expression Dashboard#formula_expression}
     *
     * @stability stable
     */
    readonly formulaExpression: string;
    /**
     * conditional_formats block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#conditional_formats Dashboard#conditional_formats}
     *
     * @stability stable
     */
    readonly conditionalFormats?: DashboardWidgetToplistDefinitionRequestFormulaConditionalFormats[];
    /**
     * limit block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#limit Dashboard#limit}
     *
     * @stability stable
     */
    readonly limit?: DashboardWidgetToplistDefinitionRequestFormulaLimit;
}
export declare function dashboardWidgetToplistDefinitionRequestFormulaToTerraform(struct?: DashboardWidgetToplistDefinitionRequestFormula): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestLogQueryComputeQuery {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Define the time interval in seconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestLogQueryComputeQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestLogQueryComputeQueryOutputReference | DashboardWidgetToplistDefinitionRequestLogQueryComputeQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestLogQueryComputeQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestLogQueryComputeQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestLogQueryComputeQuery | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _facet?;
    /**
     * @stability stable
     */
    get facet(): string;
    /**
     * @stability stable
     */
    set facet(value: string);
    /**
     * @stability stable
     */
    resetFacet(): void;
    /**
     * @stability stable
     */
    get facetInput(): string | undefined;
    private _interval?;
    /**
     * @stability stable
     */
    get interval(): number;
    /**
     * @stability stable
     */
    set interval(value: number);
    /**
     * @stability stable
     */
    resetInterval(): void;
    /**
     * @stability stable
     */
    get intervalInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestLogQueryGroupBySortQuery {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Widget sorting methods. Valid values are `asc`, `desc`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#order Dashboard#order}
     *
     * @stability stable
     */
    readonly order: string;
}
export declare function dashboardWidgetToplistDefinitionRequestLogQueryGroupBySortQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestLogQueryGroupBySortQueryOutputReference | DashboardWidgetToplistDefinitionRequestLogQueryGroupBySortQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestLogQueryGroupBySortQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestLogQueryGroupBySortQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestLogQueryGroupBySortQuery | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _facet?;
    /**
     * @stability stable
     */
    get facet(): string;
    /**
     * @stability stable
     */
    set facet(value: string);
    /**
     * @stability stable
     */
    resetFacet(): void;
    /**
     * @stability stable
     */
    get facetInput(): string | undefined;
    private _order?;
    /**
     * @stability stable
     */
    get order(): string;
    /**
     * @stability stable
     */
    set order(value: string);
    /**
     * @stability stable
     */
    get orderInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestLogQueryGroupBy {
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * The maximum number of items in the group.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#limit Dashboard#limit}
     *
     * @stability stable
     */
    readonly limit?: number;
    /**
     * sort_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#sort_query Dashboard#sort_query}
     *
     * @stability stable
     */
    readonly sortQuery?: DashboardWidgetToplistDefinitionRequestLogQueryGroupBySortQuery;
}
export declare function dashboardWidgetToplistDefinitionRequestLogQueryGroupByToTerraform(struct?: DashboardWidgetToplistDefinitionRequestLogQueryGroupBy): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestLogQueryMultiCompute {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Define the time interval in seconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestLogQueryMultiComputeToTerraform(struct?: DashboardWidgetToplistDefinitionRequestLogQueryMultiCompute): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestLogQuery {
    /**
     * The name of the index to query.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#index Dashboard#index}
     *
     * @stability stable
     */
    readonly index: string;
    /**
     * The search query to use.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#search_query Dashboard#search_query}
     *
     * @stability stable
     */
    readonly searchQuery?: string;
    /**
     * compute_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#compute_query Dashboard#compute_query}
     *
     * @stability stable
     */
    readonly computeQuery?: DashboardWidgetToplistDefinitionRequestLogQueryComputeQuery;
    /**
     * group_by block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#group_by Dashboard#group_by}
     *
     * @stability stable
     */
    readonly groupBy?: DashboardWidgetToplistDefinitionRequestLogQueryGroupBy[];
    /**
     * multi_compute block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#multi_compute Dashboard#multi_compute}
     *
     * @stability stable
     */
    readonly multiCompute?: DashboardWidgetToplistDefinitionRequestLogQueryMultiCompute[];
}
export declare function dashboardWidgetToplistDefinitionRequestLogQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestLogQueryOutputReference | DashboardWidgetToplistDefinitionRequestLogQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestLogQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestLogQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestLogQuery | undefined);
    private _index?;
    /**
     * @stability stable
     */
    get index(): string;
    /**
     * @stability stable
     */
    set index(value: string);
    /**
     * @stability stable
     */
    get indexInput(): string | undefined;
    private _searchQuery?;
    /**
     * @stability stable
     */
    get searchQuery(): string;
    /**
     * @stability stable
     */
    set searchQuery(value: string);
    /**
     * @stability stable
     */
    resetSearchQuery(): void;
    /**
     * @stability stable
     */
    get searchQueryInput(): string | undefined;
    private _computeQuery;
    /**
     * @stability stable
     */
    get computeQuery(): DashboardWidgetToplistDefinitionRequestLogQueryComputeQueryOutputReference;
    /**
     * @stability stable
     */
    putComputeQuery(value: DashboardWidgetToplistDefinitionRequestLogQueryComputeQuery): void;
    /**
     * @stability stable
     */
    resetComputeQuery(): void;
    /**
     * @stability stable
     */
    get computeQueryInput(): DashboardWidgetToplistDefinitionRequestLogQueryComputeQuery | undefined;
    private _groupBy?;
    /**
     * @stability stable
     */
    get groupBy(): DashboardWidgetToplistDefinitionRequestLogQueryGroupBy[];
    /**
     * @stability stable
     */
    set groupBy(value: DashboardWidgetToplistDefinitionRequestLogQueryGroupBy[]);
    /**
     * @stability stable
     */
    resetGroupBy(): void;
    /**
     * @stability stable
     */
    get groupByInput(): DashboardWidgetToplistDefinitionRequestLogQueryGroupBy[] | undefined;
    private _multiCompute?;
    /**
     * @stability stable
     */
    get multiCompute(): DashboardWidgetToplistDefinitionRequestLogQueryMultiCompute[];
    /**
     * @stability stable
     */
    set multiCompute(value: DashboardWidgetToplistDefinitionRequestLogQueryMultiCompute[]);
    /**
     * @stability stable
     */
    resetMultiCompute(): void;
    /**
     * @stability stable
     */
    get multiComputeInput(): DashboardWidgetToplistDefinitionRequestLogQueryMultiCompute[] | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestProcessQuery {
    /**
     * A list of processes.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#filter_by Dashboard#filter_by}
     *
     * @stability stable
     */
    readonly filterBy?: string[];
    /**
     * The max number of items in the filter list.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#limit Dashboard#limit}
     *
     * @stability stable
     */
    readonly limit?: number;
    /**
     * Your chosen metric.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#metric Dashboard#metric}
     *
     * @stability stable
     */
    readonly metric: string;
    /**
     * Your chosen search term.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#search_by Dashboard#search_by}
     *
     * @stability stable
     */
    readonly searchBy?: string;
}
export declare function dashboardWidgetToplistDefinitionRequestProcessQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestProcessQueryOutputReference | DashboardWidgetToplistDefinitionRequestProcessQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestProcessQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestProcessQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestProcessQuery | undefined);
    private _filterBy?;
    /**
     * @stability stable
     */
    get filterBy(): string[];
    /**
     * @stability stable
     */
    set filterBy(value: string[]);
    /**
     * @stability stable
     */
    resetFilterBy(): void;
    /**
     * @stability stable
     */
    get filterByInput(): string[] | undefined;
    private _limit?;
    /**
     * @stability stable
     */
    get limit(): number;
    /**
     * @stability stable
     */
    set limit(value: number);
    /**
     * @stability stable
     */
    resetLimit(): void;
    /**
     * @stability stable
     */
    get limitInput(): number | undefined;
    private _metric?;
    /**
     * @stability stable
     */
    get metric(): string;
    /**
     * @stability stable
     */
    set metric(value: string);
    /**
     * @stability stable
     */
    get metricInput(): string | undefined;
    private _searchBy?;
    /**
     * @stability stable
     */
    get searchBy(): string;
    /**
     * @stability stable
     */
    set searchBy(value: string);
    /**
     * @stability stable
     */
    resetSearchBy(): void;
    /**
     * @stability stable
     */
    get searchByInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestQueryApmDependencyStatsQuery {
    /**
     * The data source for APM Dependency Stats queries. Valid values are `apm_dependency_stats`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#data_source Dashboard#data_source}
     *
     * @stability stable
     */
    readonly dataSource: string;
    /**
     * APM Environment.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#env Dashboard#env}
     *
     * @stability stable
     */
    readonly env: string;
    /**
     * Determines whether stats for upstream or downstream dependencies should be queried.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#is_upstream Dashboard#is_upstream}
     *
     * @stability stable
     */
    readonly isUpstream?: boolean | cdktf.IResolvable;
    /**
     * The name of query for use in formulas.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#name Dashboard#name}
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Name of operation on service.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#operation_name Dashboard#operation_name}
     *
     * @stability stable
     */
    readonly operationName: string;
    /**
     * The name of the second primary tag used within APM; required when `primary_tag_value` is specified. See https://docs.datadoghq.com/tracing/guide/setting_primary_tags_to_scope/#add-a-second-primary-tag-in-datadog.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#primary_tag_name Dashboard#primary_tag_name}
     *
     * @stability stable
     */
    readonly primaryTagName?: string;
    /**
     * Filter APM data by the second primary tag. `primary_tag_name` must also be specified.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#primary_tag_value Dashboard#primary_tag_value}
     *
     * @stability stable
     */
    readonly primaryTagValue?: string;
    /**
     * APM resource.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#resource_name Dashboard#resource_name}
     *
     * @stability stable
     */
    readonly resourceName: string;
    /**
     * APM service.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#service Dashboard#service}
     *
     * @stability stable
     */
    readonly service: string;
    /**
     * APM statistic. Valid values are `avg_duration`, `avg_root_duration`, `avg_spans_per_trace`, `error_rate`, `pct_exec_time`, `pct_of_traces`, `total_traces_count`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#stat Dashboard#stat}
     *
     * @stability stable
     */
    readonly stat: string;
}
export declare function dashboardWidgetToplistDefinitionRequestQueryApmDependencyStatsQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestQueryApmDependencyStatsQueryOutputReference | DashboardWidgetToplistDefinitionRequestQueryApmDependencyStatsQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestQueryApmDependencyStatsQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestQueryApmDependencyStatsQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestQueryApmDependencyStatsQuery | undefined);
    private _dataSource?;
    /**
     * @stability stable
     */
    get dataSource(): string;
    /**
     * @stability stable
     */
    set dataSource(value: string);
    /**
     * @stability stable
     */
    get dataSourceInput(): string | undefined;
    private _env?;
    /**
     * @stability stable
     */
    get env(): string;
    /**
     * @stability stable
     */
    set env(value: string);
    /**
     * @stability stable
     */
    get envInput(): string | undefined;
    private _isUpstream?;
    /**
     * @stability stable
     */
    get isUpstream(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set isUpstream(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIsUpstream(): void;
    /**
     * @stability stable
     */
    get isUpstreamInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _operationName?;
    /**
     * @stability stable
     */
    get operationName(): string;
    /**
     * @stability stable
     */
    set operationName(value: string);
    /**
     * @stability stable
     */
    get operationNameInput(): string | undefined;
    private _primaryTagName?;
    /**
     * @stability stable
     */
    get primaryTagName(): string;
    /**
     * @stability stable
     */
    set primaryTagName(value: string);
    /**
     * @stability stable
     */
    resetPrimaryTagName(): void;
    /**
     * @stability stable
     */
    get primaryTagNameInput(): string | undefined;
    private _primaryTagValue?;
    /**
     * @stability stable
     */
    get primaryTagValue(): string;
    /**
     * @stability stable
     */
    set primaryTagValue(value: string);
    /**
     * @stability stable
     */
    resetPrimaryTagValue(): void;
    /**
     * @stability stable
     */
    get primaryTagValueInput(): string | undefined;
    private _resourceName?;
    /**
     * @stability stable
     */
    get resourceName(): string;
    /**
     * @stability stable
     */
    set resourceName(value: string);
    /**
     * @stability stable
     */
    get resourceNameInput(): string | undefined;
    private _service?;
    /**
     * @stability stable
     */
    get service(): string;
    /**
     * @stability stable
     */
    set service(value: string);
    /**
     * @stability stable
     */
    get serviceInput(): string | undefined;
    private _stat?;
    /**
     * @stability stable
     */
    get stat(): string;
    /**
     * @stability stable
     */
    set stat(value: string);
    /**
     * @stability stable
     */
    get statInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestQueryApmResourceStatsQuery {
    /**
     * The data source for APM Resource Stats queries. Valid values are `apm_resource_stats`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#data_source Dashboard#data_source}
     *
     * @stability stable
     */
    readonly dataSource: string;
    /**
     * APM Environment.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#env Dashboard#env}
     *
     * @stability stable
     */
    readonly env: string;
    /**
     * Array of fields to group results by.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#group_by Dashboard#group_by}
     *
     * @stability stable
     */
    readonly groupBy?: string[];
    /**
     * The name of query for use in formulas.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#name Dashboard#name}
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Name of operation on service.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#operation_name Dashboard#operation_name}
     *
     * @stability stable
     */
    readonly operationName?: string;
    /**
     * The name of the second primary tag used within APM; required when `primary_tag_value` is specified. See https://docs.datadoghq.com/tracing/guide/setting_primary_tags_to_scope/#add-a-second-primary-tag-in-datadog.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#primary_tag_name Dashboard#primary_tag_name}
     *
     * @stability stable
     */
    readonly primaryTagName?: string;
    /**
     * Filter APM data by the second primary tag. `primary_tag_name` must also be specified.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#primary_tag_value Dashboard#primary_tag_value}
     *
     * @stability stable
     */
    readonly primaryTagValue?: string;
    /**
     * APM resource.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#resource_name Dashboard#resource_name}
     *
     * @stability stable
     */
    readonly resourceName?: string;
    /**
     * APM service.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#service Dashboard#service}
     *
     * @stability stable
     */
    readonly service: string;
    /**
     * APM statistic. Valid values are `errors`, `error_rate`, `hits`, `latency_avg`, `latency_max`, `latency_p50`, `latency_p75`, `latency_p90`, `latency_p95`, `latency_p99`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#stat Dashboard#stat}
     *
     * @stability stable
     */
    readonly stat: string;
}
export declare function dashboardWidgetToplistDefinitionRequestQueryApmResourceStatsQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestQueryApmResourceStatsQueryOutputReference | DashboardWidgetToplistDefinitionRequestQueryApmResourceStatsQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestQueryApmResourceStatsQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestQueryApmResourceStatsQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestQueryApmResourceStatsQuery | undefined);
    private _dataSource?;
    /**
     * @stability stable
     */
    get dataSource(): string;
    /**
     * @stability stable
     */
    set dataSource(value: string);
    /**
     * @stability stable
     */
    get dataSourceInput(): string | undefined;
    private _env?;
    /**
     * @stability stable
     */
    get env(): string;
    /**
     * @stability stable
     */
    set env(value: string);
    /**
     * @stability stable
     */
    get envInput(): string | undefined;
    private _groupBy?;
    /**
     * @stability stable
     */
    get groupBy(): string[];
    /**
     * @stability stable
     */
    set groupBy(value: string[]);
    /**
     * @stability stable
     */
    resetGroupBy(): void;
    /**
     * @stability stable
     */
    get groupByInput(): string[] | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _operationName?;
    /**
     * @stability stable
     */
    get operationName(): string;
    /**
     * @stability stable
     */
    set operationName(value: string);
    /**
     * @stability stable
     */
    resetOperationName(): void;
    /**
     * @stability stable
     */
    get operationNameInput(): string | undefined;
    private _primaryTagName?;
    /**
     * @stability stable
     */
    get primaryTagName(): string;
    /**
     * @stability stable
     */
    set primaryTagName(value: string);
    /**
     * @stability stable
     */
    resetPrimaryTagName(): void;
    /**
     * @stability stable
     */
    get primaryTagNameInput(): string | undefined;
    private _primaryTagValue?;
    /**
     * @stability stable
     */
    get primaryTagValue(): string;
    /**
     * @stability stable
     */
    set primaryTagValue(value: string);
    /**
     * @stability stable
     */
    resetPrimaryTagValue(): void;
    /**
     * @stability stable
     */
    get primaryTagValueInput(): string | undefined;
    private _resourceName?;
    /**
     * @stability stable
     */
    get resourceName(): string;
    /**
     * @stability stable
     */
    set resourceName(value: string);
    /**
     * @stability stable
     */
    resetResourceName(): void;
    /**
     * @stability stable
     */
    get resourceNameInput(): string | undefined;
    private _service?;
    /**
     * @stability stable
     */
    get service(): string;
    /**
     * @stability stable
     */
    set service(value: string);
    /**
     * @stability stable
     */
    get serviceInput(): string | undefined;
    private _stat?;
    /**
     * @stability stable
     */
    get stat(): string;
    /**
     * @stability stable
     */
    set stat(value: string);
    /**
     * @stability stable
     */
    get statInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestQueryEventQueryCompute {
    /**
     * The aggregation methods for event platform queries.
     *
     * Valid values are `count`, `cardinality`, `median`, `pc75`, `pc90`, `pc95`, `pc98`, `pc99`, `sum`, `min`, `max`, `avg`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * A time interval in milliseconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
    /**
     * The measurable attribute to compute.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#metric Dashboard#metric}
     *
     * @stability stable
     */
    readonly metric?: string;
}
export declare function dashboardWidgetToplistDefinitionRequestQueryEventQueryComputeToTerraform(struct?: DashboardWidgetToplistDefinitionRequestQueryEventQueryCompute): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBySort {
    /**
     * The aggregation methods for the event platform queries.
     *
     * Valid values are `count`, `cardinality`, `median`, `pc75`, `pc90`, `pc95`, `pc98`, `pc99`, `sum`, `min`, `max`, `avg`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The metric used for sorting group by results.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#metric Dashboard#metric}
     *
     * @stability stable
     */
    readonly metric?: string;
    /**
     * Direction of sort. Valid values are `asc`, `desc`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#order Dashboard#order}
     *
     * @stability stable
     */
    readonly order?: string;
}
export declare function dashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBySortToTerraform(struct?: DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBySortOutputReference | DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBySort): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBySortOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBySort | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBySort | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _metric?;
    /**
     * @stability stable
     */
    get metric(): string;
    /**
     * @stability stable
     */
    set metric(value: string);
    /**
     * @stability stable
     */
    resetMetric(): void;
    /**
     * @stability stable
     */
    get metricInput(): string | undefined;
    private _order?;
    /**
     * @stability stable
     */
    get order(): string;
    /**
     * @stability stable
     */
    set order(value: string);
    /**
     * @stability stable
     */
    resetOrder(): void;
    /**
     * @stability stable
     */
    get orderInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBy {
    /**
     * The event facet.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet: string;
    /**
     * The number of groups to return.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#limit Dashboard#limit}
     *
     * @stability stable
     */
    readonly limit?: number;
    /**
     * sort block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#sort Dashboard#sort}
     *
     * @stability stable
     */
    readonly sort?: DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBySort;
}
export declare function dashboardWidgetToplistDefinitionRequestQueryEventQueryGroupByToTerraform(struct?: DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBy): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestQueryEventQuerySearch {
    /**
     * The events search string.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#query Dashboard#query}
     *
     * @stability stable
     */
    readonly query: string;
}
export declare function dashboardWidgetToplistDefinitionRequestQueryEventQuerySearchToTerraform(struct?: DashboardWidgetToplistDefinitionRequestQueryEventQuerySearchOutputReference | DashboardWidgetToplistDefinitionRequestQueryEventQuerySearch): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestQueryEventQuerySearchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestQueryEventQuerySearch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestQueryEventQuerySearch | undefined);
    private _query?;
    /**
     * @stability stable
     */
    get query(): string;
    /**
     * @stability stable
     */
    set query(value: string);
    /**
     * @stability stable
     */
    get queryInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestQueryEventQuery {
    /**
     * The data source for event platform-based queries. Valid values are `logs`, `spans`, `network`, `rum`, `security_signals`, `profiles`, `audit`, `events`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#data_source Dashboard#data_source}
     *
     * @stability stable
     */
    readonly dataSource: string;
    /**
     * An array of index names to query in the stream.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#indexes Dashboard#indexes}
     *
     * @stability stable
     */
    readonly indexes?: string[];
    /**
     * The name of query for use in formulas.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#name Dashboard#name}
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * compute block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#compute Dashboard#compute}
     *
     * @stability stable
     */
    readonly compute: DashboardWidgetToplistDefinitionRequestQueryEventQueryCompute[];
    /**
     * group_by block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#group_by Dashboard#group_by}
     *
     * @stability stable
     */
    readonly groupBy?: DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBy[];
    /**
     * search block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#search Dashboard#search}
     *
     * @stability stable
     */
    readonly search?: DashboardWidgetToplistDefinitionRequestQueryEventQuerySearch;
}
export declare function dashboardWidgetToplistDefinitionRequestQueryEventQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestQueryEventQueryOutputReference | DashboardWidgetToplistDefinitionRequestQueryEventQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestQueryEventQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestQueryEventQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestQueryEventQuery | undefined);
    private _dataSource?;
    /**
     * @stability stable
     */
    get dataSource(): string;
    /**
     * @stability stable
     */
    set dataSource(value: string);
    /**
     * @stability stable
     */
    get dataSourceInput(): string | undefined;
    private _indexes?;
    /**
     * @stability stable
     */
    get indexes(): string[];
    /**
     * @stability stable
     */
    set indexes(value: string[]);
    /**
     * @stability stable
     */
    resetIndexes(): void;
    /**
     * @stability stable
     */
    get indexesInput(): string[] | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _compute?;
    /**
     * @stability stable
     */
    get compute(): DashboardWidgetToplistDefinitionRequestQueryEventQueryCompute[];
    /**
     * @stability stable
     */
    set compute(value: DashboardWidgetToplistDefinitionRequestQueryEventQueryCompute[]);
    /**
     * @stability stable
     */
    get computeInput(): DashboardWidgetToplistDefinitionRequestQueryEventQueryCompute[] | undefined;
    private _groupBy?;
    /**
     * @stability stable
     */
    get groupBy(): DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBy[];
    /**
     * @stability stable
     */
    set groupBy(value: DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBy[]);
    /**
     * @stability stable
     */
    resetGroupBy(): void;
    /**
     * @stability stable
     */
    get groupByInput(): DashboardWidgetToplistDefinitionRequestQueryEventQueryGroupBy[] | undefined;
    private _search;
    /**
     * @stability stable
     */
    get search(): DashboardWidgetToplistDefinitionRequestQueryEventQuerySearchOutputReference;
    /**
     * @stability stable
     */
    putSearch(value: DashboardWidgetToplistDefinitionRequestQueryEventQuerySearch): void;
    /**
     * @stability stable
     */
    resetSearch(): void;
    /**
     * @stability stable
     */
    get searchInput(): DashboardWidgetToplistDefinitionRequestQueryEventQuerySearch | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestQueryMetricQuery {
    /**
     * The aggregation methods available for metrics queries. Valid values are `avg`, `min`, `max`, `sum`, `last`, `area`, `l2norm`, `percentile`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregator Dashboard#aggregator}
     *
     * @stability stable
     */
    readonly aggregator?: string;
    /**
     * The data source for metrics queries.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#data_source Dashboard#data_source}
     *
     * @stability stable
     */
    readonly dataSource?: string;
    /**
     * The name of the query for use in formulas.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#name Dashboard#name}
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * The metrics query definition.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#query Dashboard#query}
     *
     * @stability stable
     */
    readonly query: string;
}
export declare function dashboardWidgetToplistDefinitionRequestQueryMetricQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestQueryMetricQueryOutputReference | DashboardWidgetToplistDefinitionRequestQueryMetricQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestQueryMetricQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestQueryMetricQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestQueryMetricQuery | undefined);
    private _aggregator?;
    /**
     * @stability stable
     */
    get aggregator(): string;
    /**
     * @stability stable
     */
    set aggregator(value: string);
    /**
     * @stability stable
     */
    resetAggregator(): void;
    /**
     * @stability stable
     */
    get aggregatorInput(): string | undefined;
    private _dataSource?;
    /**
     * @stability stable
     */
    get dataSource(): string;
    /**
     * @stability stable
     */
    set dataSource(value: string);
    /**
     * @stability stable
     */
    resetDataSource(): void;
    /**
     * @stability stable
     */
    get dataSourceInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _query?;
    /**
     * @stability stable
     */
    get query(): string;
    /**
     * @stability stable
     */
    set query(value: string);
    /**
     * @stability stable
     */
    get queryInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestQueryProcessQuery {
    /**
     * The aggregation methods available for metrics queries. Valid values are `avg`, `min`, `max`, `sum`, `last`, `area`, `l2norm`, `percentile`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregator Dashboard#aggregator}
     *
     * @stability stable
     */
    readonly aggregator?: string;
    /**
     * The data source for process queries. Valid values are `process`, `container`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#data_source Dashboard#data_source}
     *
     * @stability stable
     */
    readonly dataSource: string;
    /**
     * Whether to normalize the CPU percentages.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#is_normalized_cpu Dashboard#is_normalized_cpu}
     *
     * @stability stable
     */
    readonly isNormalizedCpu?: boolean | cdktf.IResolvable;
    /**
     * The number of hits to return.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#limit Dashboard#limit}
     *
     * @stability stable
     */
    readonly limit?: number;
    /**
     * The process metric name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#metric Dashboard#metric}
     *
     * @stability stable
     */
    readonly metric: string;
    /**
     * The name of query for use in formulas.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#name Dashboard#name}
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * The direction of the sort. Valid values are `asc`, `desc`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#sort Dashboard#sort}
     *
     * @stability stable
     */
    readonly sort?: string;
    /**
     * An array of tags to filter by.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#tag_filters Dashboard#tag_filters}
     *
     * @stability stable
     */
    readonly tagFilters?: string[];
    /**
     * The text to use as a filter.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#text_filter Dashboard#text_filter}
     *
     * @stability stable
     */
    readonly textFilter?: string;
}
export declare function dashboardWidgetToplistDefinitionRequestQueryProcessQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestQueryProcessQueryOutputReference | DashboardWidgetToplistDefinitionRequestQueryProcessQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestQueryProcessQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestQueryProcessQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestQueryProcessQuery | undefined);
    private _aggregator?;
    /**
     * @stability stable
     */
    get aggregator(): string;
    /**
     * @stability stable
     */
    set aggregator(value: string);
    /**
     * @stability stable
     */
    resetAggregator(): void;
    /**
     * @stability stable
     */
    get aggregatorInput(): string | undefined;
    private _dataSource?;
    /**
     * @stability stable
     */
    get dataSource(): string;
    /**
     * @stability stable
     */
    set dataSource(value: string);
    /**
     * @stability stable
     */
    get dataSourceInput(): string | undefined;
    private _isNormalizedCpu?;
    /**
     * @stability stable
     */
    get isNormalizedCpu(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set isNormalizedCpu(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIsNormalizedCpu(): void;
    /**
     * @stability stable
     */
    get isNormalizedCpuInput(): boolean | cdktf.IResolvable | undefined;
    private _limit?;
    /**
     * @stability stable
     */
    get limit(): number;
    /**
     * @stability stable
     */
    set limit(value: number);
    /**
     * @stability stable
     */
    resetLimit(): void;
    /**
     * @stability stable
     */
    get limitInput(): number | undefined;
    private _metric?;
    /**
     * @stability stable
     */
    get metric(): string;
    /**
     * @stability stable
     */
    set metric(value: string);
    /**
     * @stability stable
     */
    get metricInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _sort?;
    /**
     * @stability stable
     */
    get sort(): string;
    /**
     * @stability stable
     */
    set sort(value: string);
    /**
     * @stability stable
     */
    resetSort(): void;
    /**
     * @stability stable
     */
    get sortInput(): string | undefined;
    private _tagFilters?;
    /**
     * @stability stable
     */
    get tagFilters(): string[];
    /**
     * @stability stable
     */
    set tagFilters(value: string[]);
    /**
     * @stability stable
     */
    resetTagFilters(): void;
    /**
     * @stability stable
     */
    get tagFiltersInput(): string[] | undefined;
    private _textFilter?;
    /**
     * @stability stable
     */
    get textFilter(): string;
    /**
     * @stability stable
     */
    set textFilter(value: string);
    /**
     * @stability stable
     */
    resetTextFilter(): void;
    /**
     * @stability stable
     */
    get textFilterInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestQuery {
    /**
     * apm_dependency_stats_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#apm_dependency_stats_query Dashboard#apm_dependency_stats_query}
     *
     * @stability stable
     */
    readonly apmDependencyStatsQuery?: DashboardWidgetToplistDefinitionRequestQueryApmDependencyStatsQuery;
    /**
     * apm_resource_stats_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#apm_resource_stats_query Dashboard#apm_resource_stats_query}
     *
     * @stability stable
     */
    readonly apmResourceStatsQuery?: DashboardWidgetToplistDefinitionRequestQueryApmResourceStatsQuery;
    /**
     * event_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#event_query Dashboard#event_query}
     *
     * @stability stable
     */
    readonly eventQuery?: DashboardWidgetToplistDefinitionRequestQueryEventQuery;
    /**
     * metric_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#metric_query Dashboard#metric_query}
     *
     * @stability stable
     */
    readonly metricQuery?: DashboardWidgetToplistDefinitionRequestQueryMetricQuery;
    /**
     * process_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#process_query Dashboard#process_query}
     *
     * @stability stable
     */
    readonly processQuery?: DashboardWidgetToplistDefinitionRequestQueryProcessQuery;
}
export declare function dashboardWidgetToplistDefinitionRequestQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestQuery): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Define the time interval in seconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestRumQueryComputeQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryComputeQueryOutputReference | DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestRumQueryComputeQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _facet?;
    /**
     * @stability stable
     */
    get facet(): string;
    /**
     * @stability stable
     */
    set facet(value: string);
    /**
     * @stability stable
     */
    resetFacet(): void;
    /**
     * @stability stable
     */
    get facetInput(): string | undefined;
    private _interval?;
    /**
     * @stability stable
     */
    get interval(): number;
    /**
     * @stability stable
     */
    set interval(value: number);
    /**
     * @stability stable
     */
    resetInterval(): void;
    /**
     * @stability stable
     */
    get intervalInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQuery {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Widget sorting methods. Valid values are `asc`, `desc`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#order Dashboard#order}
     *
     * @stability stable
     */
    readonly order: string;
}
export declare function dashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQueryOutputReference | DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQuery | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _facet?;
    /**
     * @stability stable
     */
    get facet(): string;
    /**
     * @stability stable
     */
    set facet(value: string);
    /**
     * @stability stable
     */
    resetFacet(): void;
    /**
     * @stability stable
     */
    get facetInput(): string | undefined;
    private _order?;
    /**
     * @stability stable
     */
    get order(): string;
    /**
     * @stability stable
     */
    set order(value: string);
    /**
     * @stability stable
     */
    get orderInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestRumQueryGroupBy {
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * The maximum number of items in the group.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#limit Dashboard#limit}
     *
     * @stability stable
     */
    readonly limit?: number;
    /**
     * sort_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#sort_query Dashboard#sort_query}
     *
     * @stability stable
     */
    readonly sortQuery?: DashboardWidgetToplistDefinitionRequestRumQueryGroupBySortQuery;
}
export declare function dashboardWidgetToplistDefinitionRequestRumQueryGroupByToTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryGroupBy): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Define the time interval in seconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestRumQueryMultiComputeToTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestRumQuery {
    /**
     * The name of the index to query.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#index Dashboard#index}
     *
     * @stability stable
     */
    readonly index: string;
    /**
     * The search query to use.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#search_query Dashboard#search_query}
     *
     * @stability stable
     */
    readonly searchQuery?: string;
    /**
     * compute_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#compute_query Dashboard#compute_query}
     *
     * @stability stable
     */
    readonly computeQuery?: DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery;
    /**
     * group_by block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#group_by Dashboard#group_by}
     *
     * @stability stable
     */
    readonly groupBy?: DashboardWidgetToplistDefinitionRequestRumQueryGroupBy[];
    /**
     * multi_compute block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#multi_compute Dashboard#multi_compute}
     *
     * @stability stable
     */
    readonly multiCompute?: DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute[];
}
export declare function dashboardWidgetToplistDefinitionRequestRumQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestRumQueryOutputReference | DashboardWidgetToplistDefinitionRequestRumQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestRumQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestRumQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestRumQuery | undefined);
    private _index?;
    /**
     * @stability stable
     */
    get index(): string;
    /**
     * @stability stable
     */
    set index(value: string);
    /**
     * @stability stable
     */
    get indexInput(): string | undefined;
    private _searchQuery?;
    /**
     * @stability stable
     */
    get searchQuery(): string;
    /**
     * @stability stable
     */
    set searchQuery(value: string);
    /**
     * @stability stable
     */
    resetSearchQuery(): void;
    /**
     * @stability stable
     */
    get searchQueryInput(): string | undefined;
    private _computeQuery;
    /**
     * @stability stable
     */
    get computeQuery(): DashboardWidgetToplistDefinitionRequestRumQueryComputeQueryOutputReference;
    /**
     * @stability stable
     */
    putComputeQuery(value: DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery): void;
    /**
     * @stability stable
     */
    resetComputeQuery(): void;
    /**
     * @stability stable
     */
    get computeQueryInput(): DashboardWidgetToplistDefinitionRequestRumQueryComputeQuery | undefined;
    private _groupBy?;
    /**
     * @stability stable
     */
    get groupBy(): DashboardWidgetToplistDefinitionRequestRumQueryGroupBy[];
    /**
     * @stability stable
     */
    set groupBy(value: DashboardWidgetToplistDefinitionRequestRumQueryGroupBy[]);
    /**
     * @stability stable
     */
    resetGroupBy(): void;
    /**
     * @stability stable
     */
    get groupByInput(): DashboardWidgetToplistDefinitionRequestRumQueryGroupBy[] | undefined;
    private _multiCompute?;
    /**
     * @stability stable
     */
    get multiCompute(): DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute[];
    /**
     * @stability stable
     */
    set multiCompute(value: DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute[]);
    /**
     * @stability stable
     */
    resetMultiCompute(): void;
    /**
     * @stability stable
     */
    get multiComputeInput(): DashboardWidgetToplistDefinitionRequestRumQueryMultiCompute[] | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Define the time interval in seconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryComputeQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQueryOutputReference | DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _facet?;
    /**
     * @stability stable
     */
    get facet(): string;
    /**
     * @stability stable
     */
    set facet(value: string);
    /**
     * @stability stable
     */
    resetFacet(): void;
    /**
     * @stability stable
     */
    get facetInput(): string | undefined;
    private _interval?;
    /**
     * @stability stable
     */
    get interval(): number;
    /**
     * @stability stable
     */
    set interval(value: number);
    /**
     * @stability stable
     */
    resetInterval(): void;
    /**
     * @stability stable
     */
    get intervalInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Widget sorting methods. Valid values are `asc`, `desc`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#order Dashboard#order}
     *
     * @stability stable
     */
    readonly order: string;
}
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQueryOutputReference | DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery | undefined);
    private _aggregation?;
    /**
     * @stability stable
     */
    get aggregation(): string;
    /**
     * @stability stable
     */
    set aggregation(value: string);
    /**
     * @stability stable
     */
    get aggregationInput(): string | undefined;
    private _facet?;
    /**
     * @stability stable
     */
    get facet(): string;
    /**
     * @stability stable
     */
    set facet(value: string);
    /**
     * @stability stable
     */
    resetFacet(): void;
    /**
     * @stability stable
     */
    get facetInput(): string | undefined;
    private _order?;
    /**
     * @stability stable
     */
    get order(): string;
    /**
     * @stability stable
     */
    set order(value: string);
    /**
     * @stability stable
     */
    get orderInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy {
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * The maximum number of items in the group.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#limit Dashboard#limit}
     *
     * @stability stable
     */
    readonly limit?: number;
    /**
     * sort_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#sort_query Dashboard#sort_query}
     *
     * @stability stable
     */
    readonly sortQuery?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBySortQuery;
}
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryGroupByToTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute {
    /**
     * The aggregation method.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#aggregation Dashboard#aggregation}
     *
     * @stability stable
     */
    readonly aggregation: string;
    /**
     * The facet name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#facet Dashboard#facet}
     *
     * @stability stable
     */
    readonly facet?: string;
    /**
     * Define the time interval in seconds.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#interval Dashboard#interval}
     *
     * @stability stable
     */
    readonly interval?: number;
}
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryMultiComputeToTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestSecurityQuery {
    /**
     * The name of the index to query.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#index Dashboard#index}
     *
     * @stability stable
     */
    readonly index: string;
    /**
     * The search query to use.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#search_query Dashboard#search_query}
     *
     * @stability stable
     */
    readonly searchQuery?: string;
    /**
     * compute_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#compute_query Dashboard#compute_query}
     *
     * @stability stable
     */
    readonly computeQuery?: DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery;
    /**
     * group_by block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#group_by Dashboard#group_by}
     *
     * @stability stable
     */
    readonly groupBy?: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy[];
    /**
     * multi_compute block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#multi_compute Dashboard#multi_compute}
     *
     * @stability stable
     */
    readonly multiCompute?: DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute[];
}
export declare function dashboardWidgetToplistDefinitionRequestSecurityQueryToTerraform(struct?: DashboardWidgetToplistDefinitionRequestSecurityQueryOutputReference | DashboardWidgetToplistDefinitionRequestSecurityQuery): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestSecurityQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestSecurityQuery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestSecurityQuery | undefined);
    private _index?;
    /**
     * @stability stable
     */
    get index(): string;
    /**
     * @stability stable
     */
    set index(value: string);
    /**
     * @stability stable
     */
    get indexInput(): string | undefined;
    private _searchQuery?;
    /**
     * @stability stable
     */
    get searchQuery(): string;
    /**
     * @stability stable
     */
    set searchQuery(value: string);
    /**
     * @stability stable
     */
    resetSearchQuery(): void;
    /**
     * @stability stable
     */
    get searchQueryInput(): string | undefined;
    private _computeQuery;
    /**
     * @stability stable
     */
    get computeQuery(): DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQueryOutputReference;
    /**
     * @stability stable
     */
    putComputeQuery(value: DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery): void;
    /**
     * @stability stable
     */
    resetComputeQuery(): void;
    /**
     * @stability stable
     */
    get computeQueryInput(): DashboardWidgetToplistDefinitionRequestSecurityQueryComputeQuery | undefined;
    private _groupBy?;
    /**
     * @stability stable
     */
    get groupBy(): DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy[];
    /**
     * @stability stable
     */
    set groupBy(value: DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy[]);
    /**
     * @stability stable
     */
    resetGroupBy(): void;
    /**
     * @stability stable
     */
    get groupByInput(): DashboardWidgetToplistDefinitionRequestSecurityQueryGroupBy[] | undefined;
    private _multiCompute?;
    /**
     * @stability stable
     */
    get multiCompute(): DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute[];
    /**
     * @stability stable
     */
    set multiCompute(value: DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute[]);
    /**
     * @stability stable
     */
    resetMultiCompute(): void;
    /**
     * @stability stable
     */
    get multiComputeInput(): DashboardWidgetToplistDefinitionRequestSecurityQueryMultiCompute[] | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequestStyle {
    /**
     * A color palette to apply to the widget. The available options are available at: https://docs.datadoghq.com/dashboards/widgets/timeseries/#appearance.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#palette Dashboard#palette}
     *
     * @stability stable
     */
    readonly palette?: string;
}
export declare function dashboardWidgetToplistDefinitionRequestStyleToTerraform(struct?: DashboardWidgetToplistDefinitionRequestStyleOutputReference | DashboardWidgetToplistDefinitionRequestStyle): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionRequestStyleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinitionRequestStyle | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinitionRequestStyle | undefined);
    private _palette?;
    /**
     * @stability stable
     */
    get palette(): string;
    /**
     * @stability stable
     */
    set palette(value: string);
    /**
     * @stability stable
     */
    resetPalette(): void;
    /**
     * @stability stable
     */
    get paletteInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinitionRequest {
    /**
     * The metric query to use for this widget.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#q Dashboard#q}
     *
     * @stability stable
     */
    readonly q?: string;
    /**
     * apm_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#apm_query Dashboard#apm_query}
     *
     * @stability stable
     */
    readonly apmQuery?: DashboardWidgetToplistDefinitionRequestApmQuery;
    /**
     * audit_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#audit_query Dashboard#audit_query}
     *
     * @stability stable
     */
    readonly auditQuery?: DashboardWidgetToplistDefinitionRequestAuditQuery;
    /**
     * conditional_formats block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#conditional_formats Dashboard#conditional_formats}
     *
     * @stability stable
     */
    readonly conditionalFormats?: DashboardWidgetToplistDefinitionRequestConditionalFormats[];
    /**
     * formula block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#formula Dashboard#formula}
     *
     * @stability stable
     */
    readonly formula?: DashboardWidgetToplistDefinitionRequestFormula[];
    /**
     * log_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#log_query Dashboard#log_query}
     *
     * @stability stable
     */
    readonly logQuery?: DashboardWidgetToplistDefinitionRequestLogQuery;
    /**
     * process_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#process_query Dashboard#process_query}
     *
     * @stability stable
     */
    readonly processQuery?: DashboardWidgetToplistDefinitionRequestProcessQuery;
    /**
     * query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#query Dashboard#query}
     *
     * @stability stable
     */
    readonly query?: DashboardWidgetToplistDefinitionRequestQuery[];
    /**
     * rum_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#rum_query Dashboard#rum_query}
     *
     * @stability stable
     */
    readonly rumQuery?: DashboardWidgetToplistDefinitionRequestRumQuery;
    /**
     * security_query block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#security_query Dashboard#security_query}
     *
     * @stability stable
     */
    readonly securityQuery?: DashboardWidgetToplistDefinitionRequestSecurityQuery;
    /**
     * style block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#style Dashboard#style}
     *
     * @stability stable
     */
    readonly style?: DashboardWidgetToplistDefinitionRequestStyle;
}
export declare function dashboardWidgetToplistDefinitionRequestToTerraform(struct?: DashboardWidgetToplistDefinitionRequest): any;
/**
 * @stability stable
 */
export interface DashboardWidgetToplistDefinition {
    /**
     * The timeframe to use when displaying the widget.
     *
     * Valid values are `1m`, `5m`, `10m`, `15m`, `30m`, `1h`, `4h`, `1d`, `2d`, `1w`, `1mo`, `3mo`, `6mo`, `1y`, `alert`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#live_span Dashboard#live_span}
     *
     * @stability stable
     */
    readonly liveSpan?: string;
    /**
     * The title of the widget.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#title Dashboard#title}
     *
     * @stability stable
     */
    readonly title?: string;
    /**
     * The alignment of the widget's title. Valid values are `center`, `left`, `right`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#title_align Dashboard#title_align}
     *
     * @stability stable
     */
    readonly titleAlign?: string;
    /**
     * The size of the widget's title (defaults to 16).
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#title_size Dashboard#title_size}
     *
     * @stability stable
     */
    readonly titleSize?: string;
    /**
     * custom_link block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#custom_link Dashboard#custom_link}
     *
     * @stability stable
     */
    readonly customLink?: DashboardWidgetToplistDefinitionCustomLink[];
    /**
     * request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#request Dashboard#request}
     *
     * @stability stable
     */
    readonly request?: DashboardWidgetToplistDefinitionRequest[];
}
export declare function dashboardWidgetToplistDefinitionToTerraform(struct?: DashboardWidgetToplistDefinitionOutputReference | DashboardWidgetToplistDefinition): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetToplistDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetToplistDefinition | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetToplistDefinition | undefined);
    private _liveSpan?;
    /**
     * @stability stable
     */
    get liveSpan(): string;
    /**
     * @stability stable
     */
    set liveSpan(value: string);
    /**
     * @stability stable
     */
    resetLiveSpan(): void;
    /**
     * @stability stable
     */
    get liveSpanInput(): string | undefined;
    private _title?;
    /**
     * @stability stable
     */
    get title(): string;
    /**
     * @stability stable
     */
    set title(value: string);
    /**
     * @stability stable
     */
    resetTitle(): void;
    /**
     * @stability stable
     */
    get titleInput(): string | undefined;
    private _titleAlign?;
    /**
     * @stability stable
     */
    get titleAlign(): string;
    /**
     * @stability stable
     */
    set titleAlign(value: string);
    /**
     * @stability stable
     */
    resetTitleAlign(): void;
    /**
     * @stability stable
     */
    get titleAlignInput(): string | undefined;
    private _titleSize?;
    /**
     * @stability stable
     */
    get titleSize(): string;
    /**
     * @stability stable
     */
    set titleSize(value: string);
    /**
     * @stability stable
     */
    resetTitleSize(): void;
    /**
     * @stability stable
     */
    get titleSizeInput(): string | undefined;
    private _customLink?;
    /**
     * @stability stable
     */
    get customLink(): DashboardWidgetToplistDefinitionCustomLink[];
    /**
     * @stability stable
     */
    set customLink(value: DashboardWidgetToplistDefinitionCustomLink[]);
    /**
     * @stability stable
     */
    resetCustomLink(): void;
    /**
     * @stability stable
     */
    get customLinkInput(): DashboardWidgetToplistDefinitionCustomLink[] | undefined;
    private _request?;
    /**
     * @stability stable
     */
    get request(): DashboardWidgetToplistDefinitionRequest[];
    /**
     * @stability stable
     */
    set request(value: DashboardWidgetToplistDefinitionRequest[]);
    /**
     * @stability stable
     */
    resetRequest(): void;
    /**
     * @stability stable
     */
    get requestInput(): DashboardWidgetToplistDefinitionRequest[] | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetTraceServiceDefinition {
    /**
     * The number of columns to display. Valid values are `one_column`, `two_column`, `three_column`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#display_format Dashboard#display_format}
     *
     * @stability stable
     */
    readonly displayFormat?: string;
    /**
     * APM environment.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#env Dashboard#env}
     *
     * @stability stable
     */
    readonly env: string;
    /**
     * The timeframe to use when displaying the widget.
     *
     * Valid values are `1m`, `5m`, `10m`, `15m`, `30m`, `1h`, `4h`, `1d`, `2d`, `1w`, `1mo`, `3mo`, `6mo`, `1y`, `alert`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#live_span Dashboard#live_span}
     *
     * @stability stable
     */
    readonly liveSpan?: string;
    /**
     * APM service.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#service Dashboard#service}
     *
     * @stability stable
     */
    readonly service: string;
    /**
     * Whether to show the latency breakdown or not.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#show_breakdown Dashboard#show_breakdown}
     *
     * @stability stable
     */
    readonly showBreakdown?: boolean | cdktf.IResolvable;
    /**
     * Whether to show the latency distribution or not.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#show_distribution Dashboard#show_distribution}
     *
     * @stability stable
     */
    readonly showDistribution?: boolean | cdktf.IResolvable;
    /**
     * Whether to show the error metrics or not.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#show_errors Dashboard#show_errors}
     *
     * @stability stable
     */
    readonly showErrors?: boolean | cdktf.IResolvable;
    /**
     * Whether to show the hits metrics or not.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#show_hits Dashboard#show_hits}
     *
     * @stability stable
     */
    readonly showHits?: boolean | cdktf.IResolvable;
    /**
     * Whether to show the latency metrics or not.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#show_latency Dashboard#show_latency}
     *
     * @stability stable
     */
    readonly showLatency?: boolean | cdktf.IResolvable;
    /**
     * Whether to show the resource list or not.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#show_resource_list Dashboard#show_resource_list}
     *
     * @stability stable
     */
    readonly showResourceList?: boolean | cdktf.IResolvable;
    /**
     * The size of the widget. Valid values are `small`, `medium`, `large`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#size_format Dashboard#size_format}
     *
     * @stability stable
     */
    readonly sizeFormat?: string;
    /**
     * APM span name.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#span_name Dashboard#span_name}
     *
     * @stability stable
     */
    readonly spanName: string;
    /**
     * The title of the widget.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#title Dashboard#title}
     *
     * @stability stable
     */
    readonly title?: string;
    /**
     * The alignment of the widget's title. Valid values are `center`, `left`, `right`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#title_align Dashboard#title_align}
     *
     * @stability stable
     */
    readonly titleAlign?: string;
    /**
     * The size of the widget's title (defaults to 16).
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#title_size Dashboard#title_size}
     *
     * @stability stable
     */
    readonly titleSize?: string;
}
export declare function dashboardWidgetTraceServiceDefinitionToTerraform(struct?: DashboardWidgetTraceServiceDefinitionOutputReference | DashboardWidgetTraceServiceDefinition): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetTraceServiceDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetTraceServiceDefinition | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetTraceServiceDefinition | undefined);
    private _displayFormat?;
    /**
     * @stability stable
     */
    get displayFormat(): string;
    /**
     * @stability stable
     */
    set displayFormat(value: string);
    /**
     * @stability stable
     */
    resetDisplayFormat(): void;
    /**
     * @stability stable
     */
    get displayFormatInput(): string | undefined;
    private _env?;
    /**
     * @stability stable
     */
    get env(): string;
    /**
     * @stability stable
     */
    set env(value: string);
    /**
     * @stability stable
     */
    get envInput(): string | undefined;
    private _liveSpan?;
    /**
     * @stability stable
     */
    get liveSpan(): string;
    /**
     * @stability stable
     */
    set liveSpan(value: string);
    /**
     * @stability stable
     */
    resetLiveSpan(): void;
    /**
     * @stability stable
     */
    get liveSpanInput(): string | undefined;
    private _service?;
    /**
     * @stability stable
     */
    get service(): string;
    /**
     * @stability stable
     */
    set service(value: string);
    /**
     * @stability stable
     */
    get serviceInput(): string | undefined;
    private _showBreakdown?;
    /**
     * @stability stable
     */
    get showBreakdown(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set showBreakdown(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetShowBreakdown(): void;
    /**
     * @stability stable
     */
    get showBreakdownInput(): boolean | cdktf.IResolvable | undefined;
    private _showDistribution?;
    /**
     * @stability stable
     */
    get showDistribution(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set showDistribution(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetShowDistribution(): void;
    /**
     * @stability stable
     */
    get showDistributionInput(): boolean | cdktf.IResolvable | undefined;
    private _showErrors?;
    /**
     * @stability stable
     */
    get showErrors(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set showErrors(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetShowErrors(): void;
    /**
     * @stability stable
     */
    get showErrorsInput(): boolean | cdktf.IResolvable | undefined;
    private _showHits?;
    /**
     * @stability stable
     */
    get showHits(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set showHits(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetShowHits(): void;
    /**
     * @stability stable
     */
    get showHitsInput(): boolean | cdktf.IResolvable | undefined;
    private _showLatency?;
    /**
     * @stability stable
     */
    get showLatency(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set showLatency(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetShowLatency(): void;
    /**
     * @stability stable
     */
    get showLatencyInput(): boolean | cdktf.IResolvable | undefined;
    private _showResourceList?;
    /**
     * @stability stable
     */
    get showResourceList(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set showResourceList(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetShowResourceList(): void;
    /**
     * @stability stable
     */
    get showResourceListInput(): boolean | cdktf.IResolvable | undefined;
    private _sizeFormat?;
    /**
     * @stability stable
     */
    get sizeFormat(): string;
    /**
     * @stability stable
     */
    set sizeFormat(value: string);
    /**
     * @stability stable
     */
    resetSizeFormat(): void;
    /**
     * @stability stable
     */
    get sizeFormatInput(): string | undefined;
    private _spanName?;
    /**
     * @stability stable
     */
    get spanName(): string;
    /**
     * @stability stable
     */
    set spanName(value: string);
    /**
     * @stability stable
     */
    get spanNameInput(): string | undefined;
    private _title?;
    /**
     * @stability stable
     */
    get title(): string;
    /**
     * @stability stable
     */
    set title(value: string);
    /**
     * @stability stable
     */
    resetTitle(): void;
    /**
     * @stability stable
     */
    get titleInput(): string | undefined;
    private _titleAlign?;
    /**
     * @stability stable
     */
    get titleAlign(): string;
    /**
     * @stability stable
     */
    set titleAlign(value: string);
    /**
     * @stability stable
     */
    resetTitleAlign(): void;
    /**
     * @stability stable
     */
    get titleAlignInput(): string | undefined;
    private _titleSize?;
    /**
     * @stability stable
     */
    get titleSize(): string;
    /**
     * @stability stable
     */
    set titleSize(value: string);
    /**
     * @stability stable
     */
    resetTitleSize(): void;
    /**
     * @stability stable
     */
    get titleSizeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidgetWidgetLayout {
    /**
     * The height of the widget.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#height Dashboard#height}
     *
     * @stability stable
     */
    readonly height: number;
    /**
     * Whether the widget should be the first one on the second column in high density or not.
     *
     * Only for the new dashboard layout and only one widget in the dashboard should have this property set to `true`.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#is_column_break Dashboard#is_column_break}
     *
     * @stability stable
     */
    readonly isColumnBreak?: boolean | cdktf.IResolvable;
    /**
     * The width of the widget.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#width Dashboard#width}
     *
     * @stability stable
     */
    readonly width: number;
    /**
     * The position of the widget on the x (horizontal) axis. Should be greater than or equal to 0.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#x Dashboard#x}
     *
     * @stability stable
     */
    readonly x: number;
    /**
     * The position of the widget on the y (vertical) axis. Should be greater than or equal to 0.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#y Dashboard#y}
     *
     * @stability stable
     */
    readonly y: number;
}
export declare function dashboardWidgetWidgetLayoutToTerraform(struct?: DashboardWidgetWidgetLayoutOutputReference | DashboardWidgetWidgetLayout): any;
/**
 * @stability stable
 */
export declare class DashboardWidgetWidgetLayoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DashboardWidgetWidgetLayout | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DashboardWidgetWidgetLayout | undefined);
    private _height?;
    /**
     * @stability stable
     */
    get height(): number;
    /**
     * @stability stable
     */
    set height(value: number);
    /**
     * @stability stable
     */
    get heightInput(): number | undefined;
    private _isColumnBreak?;
    /**
     * @stability stable
     */
    get isColumnBreak(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set isColumnBreak(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIsColumnBreak(): void;
    /**
     * @stability stable
     */
    get isColumnBreakInput(): boolean | cdktf.IResolvable | undefined;
    private _width?;
    /**
     * @stability stable
     */
    get width(): number;
    /**
     * @stability stable
     */
    set width(value: number);
    /**
     * @stability stable
     */
    get widthInput(): number | undefined;
    private _x?;
    /**
     * @stability stable
     */
    get x(): number;
    /**
     * @stability stable
     */
    set x(value: number);
    /**
     * @stability stable
     */
    get xInput(): number | undefined;
    private _y?;
    /**
     * @stability stable
     */
    get y(): number;
    /**
     * @stability stable
     */
    set y(value: number);
    /**
     * @stability stable
     */
    get yInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface DashboardWidget {
    /**
     * alert_graph_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#alert_graph_definition Dashboard#alert_graph_definition}
     *
     * @stability stable
     */
    readonly alertGraphDefinition?: DashboardWidgetAlertGraphDefinition;
    /**
     * alert_value_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#alert_value_definition Dashboard#alert_value_definition}
     *
     * @stability stable
     */
    readonly alertValueDefinition?: DashboardWidgetAlertValueDefinition;
    /**
     * change_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#change_definition Dashboard#change_definition}
     *
     * @stability stable
     */
    readonly changeDefinition?: DashboardWidgetChangeDefinition;
    /**
     * check_status_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#check_status_definition Dashboard#check_status_definition}
     *
     * @stability stable
     */
    readonly checkStatusDefinition?: DashboardWidgetCheckStatusDefinition;
    /**
     * distribution_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#distribution_definition Dashboard#distribution_definition}
     *
     * @stability stable
     */
    readonly distributionDefinition?: DashboardWidgetDistributionDefinition;
    /**
     * event_stream_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#event_stream_definition Dashboard#event_stream_definition}
     *
     * @stability stable
     */
    readonly eventStreamDefinition?: DashboardWidgetEventStreamDefinition;
    /**
     * event_timeline_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#event_timeline_definition Dashboard#event_timeline_definition}
     *
     * @stability stable
     */
    readonly eventTimelineDefinition?: DashboardWidgetEventTimelineDefinition;
    /**
     * free_text_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#free_text_definition Dashboard#free_text_definition}
     *
     * @stability stable
     */
    readonly freeTextDefinition?: DashboardWidgetFreeTextDefinition;
    /**
     * geomap_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#geomap_definition Dashboard#geomap_definition}
     *
     * @stability stable
     */
    readonly geomapDefinition?: DashboardWidgetGeomapDefinition;
    /**
     * group_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#group_definition Dashboard#group_definition}
     *
     * @stability stable
     */
    readonly groupDefinition?: DashboardWidgetGroupDefinition;
    /**
     * heatmap_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#heatmap_definition Dashboard#heatmap_definition}
     *
     * @stability stable
     */
    readonly heatmapDefinition?: DashboardWidgetHeatmapDefinition;
    /**
     * hostmap_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#hostmap_definition Dashboard#hostmap_definition}
     *
     * @stability stable
     */
    readonly hostmapDefinition?: DashboardWidgetHostmapDefinition;
    /**
     * iframe_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#iframe_definition Dashboard#iframe_definition}
     *
     * @stability stable
     */
    readonly iframeDefinition?: DashboardWidgetIframeDefinition;
    /**
     * image_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#image_definition Dashboard#image_definition}
     *
     * @stability stable
     */
    readonly imageDefinition?: DashboardWidgetImageDefinition;
    /**
     * log_stream_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#log_stream_definition Dashboard#log_stream_definition}
     *
     * @stability stable
     */
    readonly logStreamDefinition?: DashboardWidgetLogStreamDefinition;
    /**
     * manage_status_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#manage_status_definition Dashboard#manage_status_definition}
     *
     * @stability stable
     */
    readonly manageStatusDefinition?: DashboardWidgetManageStatusDefinition;
    /**
     * note_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#note_definition Dashboard#note_definition}
     *
     * @stability stable
     */
    readonly noteDefinition?: DashboardWidgetNoteDefinition;
    /**
     * query_table_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#query_table_definition Dashboard#query_table_definition}
     *
     * @stability stable
     */
    readonly queryTableDefinition?: DashboardWidgetQueryTableDefinition;
    /**
     * query_value_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#query_value_definition Dashboard#query_value_definition}
     *
     * @stability stable
     */
    readonly queryValueDefinition?: DashboardWidgetQueryValueDefinition;
    /**
     * scatterplot_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#scatterplot_definition Dashboard#scatterplot_definition}
     *
     * @stability stable
     */
    readonly scatterplotDefinition?: DashboardWidgetScatterplotDefinition;
    /**
     * service_level_objective_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#service_level_objective_definition Dashboard#service_level_objective_definition}
     *
     * @stability stable
     */
    readonly serviceLevelObjectiveDefinition?: DashboardWidgetServiceLevelObjectiveDefinition;
    /**
     * servicemap_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#servicemap_definition Dashboard#servicemap_definition}
     *
     * @stability stable
     */
    readonly servicemapDefinition?: DashboardWidgetServicemapDefinition;
    /**
     * timeseries_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#timeseries_definition Dashboard#timeseries_definition}
     *
     * @stability stable
     */
    readonly timeseriesDefinition?: DashboardWidgetTimeseriesDefinition;
    /**
     * toplist_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#toplist_definition Dashboard#toplist_definition}
     *
     * @stability stable
     */
    readonly toplistDefinition?: DashboardWidgetToplistDefinition;
    /**
     * trace_service_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#trace_service_definition Dashboard#trace_service_definition}
     *
     * @stability stable
     */
    readonly traceServiceDefinition?: DashboardWidgetTraceServiceDefinition;
    /**
     * widget_layout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/r/dashboard#widget_layout Dashboard#widget_layout}
     *
     * @stability stable
     */
    readonly widgetLayout?: DashboardWidgetWidgetLayout;
}
export declare function dashboardWidgetToTerraform(struct?: DashboardWidget): any;
